org.apache.tinkerpop.gremlin.process.traversal

## Interface TraversalStrategy.ProviderOptimizationStrategy

- All Superinterfaces:
    Comparable<Class<? extends TraversalStrategy>>, Serializable, TraversalStrategy<TraversalStrategy.ProviderOptimizationStrategy>
  All Known Implementing Classes:
    Neo4jGraphStepStrategy, SparkInterceptorStrategy, SparkSingleIterationStrategy, TinkerGraphCountStrategy, TinkerGraphStepStrategy
  Enclosing interface:
    TraversalStrategy<S extends TraversalStrategy>

      public static interface TraversalStrategy.ProviderOptimizationStrategy
      extends TraversalStrategy<TraversalStrategy.ProviderOptimizationStrategy>

  Implemented by strategies that rewrite the traversal to be more efficient, but with the same semantics. This is for graph system/language/driver providers that want to rewrite a traversal using provider specific steps.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.TraversalStrategy

      `TraversalStrategy.DecorationStrategy, TraversalStrategy.FinalizationStrategy, TraversalStrategy.OptimizationStrategy, TraversalStrategy.ProviderOptimizationStrategy, TraversalStrategy.VerificationStrategy`

  - ### Field Summary

    - ### Fields inherited from interface org.apache.tinkerpop.gremlin.process.traversal.TraversalStrategy

      `STRATEGY`

  - ### Method Summary

    All Methods Instance Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default int` | `compareTo(Class<? extends TraversalStrategy> otherTraversalCategory)`
    `default Class<TraversalStrategy.ProviderOptimizationStrategy>` | `getTraversalCategory()` The type of traversal strategy -- i.e.

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.TraversalStrategy

      `apply, applyPost, applyPrior, getConfiguration`

- - ### Method Detail

    - #### getTraversalCategory

          default Class<TraversalStrategy.ProviderOptimizationStrategy> getTraversalCategory()

      Description copied from interface: `TraversalStrategy`
      The type of traversal strategy -- i.e. `TraversalStrategy.DecorationStrategy`, `TraversalStrategy.OptimizationStrategy`, `TraversalStrategy.FinalizationStrategy`, or `TraversalStrategy.VerificationStrategy`.
      Specified by:
        `getTraversalCategory` in interface `TraversalStrategy<TraversalStrategy.ProviderOptimizationStrategy>`
      Returns:
        the traversal strategy category class

    - #### compareTo

          default int compareTo(Class<? extends TraversalStrategy> otherTraversalCategory)

      Specified by:
        `compareTo` in interface `Comparable<Class<? extends TraversalStrategy>>`
      Specified by:
        `compareTo` in interface `TraversalStrategy<TraversalStrategy.ProviderOptimizationStrategy>`

Copyright © 2013–2020 Apache Software Foundation. All rights reserved.